Subject: Re: [karp] I-D Action: draft-ietf-karp-routing-tcp-analysis-02.txt

From: Joe Touch <[email-masked]>
Date: Fri, 06 Jul 2012 16:37:59 -0700

Hi, all,

I note that this doc has numerous places where it refers to either TCP 
MD5 or TCP AO that need attention.

A full pass would be useful. Some cursory observations follow to kickoff 
such a pass.

Joe

This doc continues to refer to TCP MD5, but fails to note that this 
protocol has been deprecated. It'd be useful to indicate that clearly, 
even noting that it remains in use if necessary.

Sec 2.2 discusses problems changing keys with TCP MD5, but should also 
then note that this has been overcome in TCP AO, whether using manual 
keying or an out-of-band KMP.

Sec 2.3.1.2 suggests use of a stronger hashing algorithm (implied within 
TCP MD5). It should not suggest an alternative that has not been 
proposed; it should note that SHA1 is one of the algorithms already 
supported by TCP AO.

Sec 2.5's first paragraph should be revised to refer more directly to MSDP.

Sec 4 discusses TCP AO, but claims "Even when keys are
    configured manually, a method for when to start using the new keys or
    stop using old keys has not been defined"

In TCP AO's architecture, a method for starting/stopping keys would be 
part of a KMP. No such KMP is defined, but this is not a deficiency of 
TCP AO.

it also states: "Also TCP-AO does not address the issue of 
connectionless reset, as it
    applies to routers that do not store MKT across reboots."

See RFC 5925 Sec 7.27.

The doc also states:
    As stated earlier TCP-AO [RFC5925] and its accompanying document
    Crypto Algorithms for TCP-AO [RFC5926] suggest that two MAC
    algorithms that MUST be supported are HMAC-SHA-1-96 as specified in
    HMAC [RFC2104] and AES-128-CMAC-96 as specified in NIST-SP800-38B
    [NIST-SP800-38B].

They don't suggest it; they require it.

On 6/23/2012 5:28 PM, [email-masked] wrote:
>
> A New Internet-Draft is available from the on-line Internet-Drafts directories.
>   This draft is a work item of the Keying and Authentication for Routing Protocols Working Group of the IETF.
>
> 	Title           : Analysis of BGP, LDP, PCEP and MSDP Issues According to KARP Design Guide
> 	Author(s)       : Mahesh Jethanandani
>                            Keyur Patel
>                            Lianshu Zheng
> 	Filename        : draft-ietf-karp-routing-tcp-analysis-02.txt
> 	Pages           : 17
> 	Date            : 2012-06-23
>
> Abstract:
>     This document analyzes BGP, LDP, PCEP and MSDP according to
>     guidelines set forth in section 4.2 of Keying and Authentication for
>     Routing Protocols Design Guidelines [RFC6518].
>
> The IETF datatracker status page for this draft is:
> https://datatracker.ietf.org/doc/draft-ietf-karp-routing-tcp-analysis
>
> There's also a htmlized version available at:
> http://tools.ietf.org/html/draft-ietf-karp-routing-tcp-analysis-02
>
> A diff from previous version is available at:
> http://tools.ietf.org/rfcdiff?url2=draft-ietf-karp-routing-tcp-analysis-02
>
>
> Internet-Drafts are also available by anonymous FTP at:
> ftp://ftp.ietf.org/internet-drafts/
>
> _______________________________________________
> karp mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/karp
>

---

From: Mahesh Jethanandani <[email-masked]>
Date: Sat, 7 Jul 2012 16:18:26 -0700

On Jul 6, 2012, at 4:37 PM, Joe Touch wrote:

> This doc continues to refer to TCP MD5, but fails to note that this protocol has been deprecated. It'd be useful to indicate that clearly, even noting that it remains in use if necessary.

The word deprecated has not been appended to TCP MD5.

> 
> Sec 2.2 discusses problems changing keys with TCP MD5, but should also then note that this has been overcome in TCP AO, whether using manual keying or an out-of-band KMP.
> 
> Sec 2.3.1.2 suggests use of a stronger hashing algorithm (implied within TCP MD5). It should not suggest an alternative that has not been proposed; it should note that SHA1 is one of the algorithms already supported by TCP AO.

Done.

> Sec 2.5's first paragraph should be revised to refer more directly to MSDP.

Done.

> In TCP AO's architecture, a method for starting/stopping keys would be part of a KMP. No such KMP is defined, but this is not a deficiency of TCP AO.

This statement has been taken out.

> 
> it also states: "Also TCP-AO does not address the issue of connectionless reset, as it

I think you meant Section 7.7. That section suggests that routers store traffic keys in storage. The statement above is for cases where routers cannot or do not want to store MKT across reboots. In that case, TCP-AO does not address connectionless reset.

> They don't suggest it; they require it.

The document has already been reworded around this section.

>> ftp://ftp.ietf.org/internet-drafts/

Mahesh Jethanandani
[email-masked]

---

From: Joe Touch <[email-masked]>
Date: Sat, 7 Jul 2012 17:38:36 -0700

Notes below. 

> The word deprecated has not been appended to TCP MD5.

It's not 'historic' but AO obsoletes it. 

> I think you meant Section 7.7

Yes. Autocorrect was too eager. 

> That section suggests that routers store traffic keys in storage. The statement above is for cases where routers cannot or do not want to store MKT across reboots. In that case, TCP-AO does not address connectionless reset.

It does in detail - recommending use of TCP keepaives, BGP graceful restart, and clearing out excess idle connection state. That's hardly considered not addressing it.